/* V.V.Zavjalov, 11.07.2001 */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>

#define BUFSIZE 1024

main(int ARGC, char *ARGV[]){
  int    inp1[2], inp2[2], outp[2];
  pid_t  in1, in2, out;
  char   *djpeg_name="djpeg";
  char   *cjpeg_name="cjpeg";
  char   *djpeg1_args[3]={djpeg_name, NULL, NULL};
  char   *djpeg2_args[3]={djpeg_name, NULL, NULL};
  char   *cjpeg_args[3]={cjpeg_name, NULL, NULL};
  unsigned char   c1[BUFSIZE], c2[BUFSIZE], c[BUFSIZE];
  int    nlcount=0;
  int    i, size;
  int    aaa;

  if (ARGC!=3){
    fprintf(stderr,"usage: %s <jpeg-file> <jpeg-mask>\n", ARGV[0]);
    exit(-1);
  }

  djpeg1_args[1]=ARGV[1];
  djpeg2_args[1]=ARGV[2];
/*  cjpeg_args[0]=ARGV[3];*/
  
  if ((pipe(inp1)!=0) || (pipe(inp2)!=0) || (pipe(outp)!=0)){
    fprintf(stderr,"can't opet pipe\n");
    exit(-1);
  }

  in1=fork();
  if (in1==-1){
    fprintf(stderr,"can't do fork\n");
    exit(-1);
  }
  else if (in1==0){
    close(inp1[0]); /* 0 -- for reading */
    close(STDOUT_FILENO);
    dup2(inp1[1], STDOUT_FILENO);
    close(inp1[1]);
    execvp(djpeg_name, djpeg1_args);
  }

  in2=fork();
  if (in2==-1){
    fprintf(stderr,"can't do fork\n");
    exit(-1);
  }
  else if (in2==0){
    close(inp2[0]); /* 0 -- for reading */
    close(STDOUT_FILENO);
    dup2(inp2[1], STDOUT_FILENO);
    close(inp2[1]);
    execvp(djpeg_name, djpeg2_args);
  }

  out=fork();
  if (out==-1){
    fprintf(stderr,"can't do fork\n");
    exit(-1);
  }
  else if (out==0){
    close(outp[1]); /* 0 -- for writing */
    close(STDIN_FILENO);
    dup2(outp[0], STDIN_FILENO);
    close(outp[0]);
    execvp(cjpeg_name, cjpeg_args);
  }

  do {
   size=read(inp1[0], c1, BUFSIZE);
   size=read(inp2[0], c2, BUFSIZE);
   for (i=0; i<size; ++i){

      if ((nlcount<3) && (c1[i]!=c2[i])){
        fprintf(stderr,"differett files!\n");
        exit(-1);
      }
      if (nlcount>=3) { 
        aaa=(c1[i]*255)/c2[i]; 
        if (aaa<0)   {aaa=0;}
        if (aaa>255) {aaa=255;}
        c[i]=(unsigned char)aaa;
      } 
      else { c[i]=c1[i]; }
      if (c1[i]=='\n'){++nlcount;}
    }
    write(outp[1], c, size);
  } while (size==BUFSIZE);
} 